import { OnDestroy, ElementRef } from '@angular/core';
import { HtmlDomService } from '../../commons/services/htmldom.service';
import { DomAttr } from '../../commons/extends/attr.class';
import { Toggle } from '../../commons/interfaces/toggle.interface';
import { ToggleDirective } from '../../commons/directives/toggle.directives';
export declare const styleStr = "\n.ts-datepicker-ym {height: 300px;width: 280px;}\n.ts-datepicker-ym-toolbar {height: 30px;}\n.ts-datepicker-ym tr {line-height: 25px;}\n.ts-datepicker-ym td {width: 33%;}\n.ts-datepicker-ym td:hover button {color: white;background-color: #3e9cff;border-color: #3e9cff;}\n.ts-datepicker-hm { height: 300px; width: 280px;}\n.ts-datepicker-hm-box { width: 33.33%; line-height: 25px;}\n.ts-time-item { line-height: 30px;}\n.ts-time-item.active { font-size: 20px;}";
export declare class Base extends DomAttr implements OnDestroy, Toggle {
    private html;
    pad: ElementRef;
    show: boolean;
    toggleDom: HTMLElement;
    ticking: boolean;
    datepickerStyle: {
        top: string;
        left: string;
        display: string;
        position: string;
    };
    private value;
    autoHandle: () => void;
    applyChange: (value: any) => void;
    constructor(html: HtmlDomService);
    ngOnDestroy(): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    toggle(): void;
    bind(toggleDirective: ToggleDirective): void;
    autoPosition(): void;
    tryClose($event: any): void;
}
