"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var attr_class_1 = require("../../commons/extends/attr.class");
exports.styleStr = "\n.ts-datepicker-ym {height: 300px;width: 280px;}\n.ts-datepicker-ym-toolbar {height: 30px;}\n.ts-datepicker-ym tr {line-height: 25px;}\n.ts-datepicker-ym td {width: 33%;}\n.ts-datepicker-ym td:hover button {color: white;background-color: #3e9cff;border-color: #3e9cff;}\n.ts-datepicker-hm { height: 300px; width: 280px;}\n.ts-datepicker-hm-box { width: 33.33%; line-height: 25px;}\n.ts-time-item { line-height: 30px;}\n.ts-time-item.active { font-size: 20px;}";
var Base = (function (_super) {
    __extends(Base, _super);
    function Base(html) {
        var _this = _super.call(this) || this;
        _this.html = html;
        _this.ticking = false;
        _this.datepickerStyle = { top: '0', left: '0', display: 'none', position: 'absolute' };
        _this.applyChange = function (value) { };
        _this.show = false;
        return _this;
    }
    Base.prototype.ngOnDestroy = function () {
        window.removeEventListener('scroll', this.autoHandle);
        window.removeEventListener('resize', this.autoHandle);
    };
    Base.prototype.registerOnChange = function (fn) { this.applyChange = fn; };
    Base.prototype.registerOnTouched = function (fn) { };
    Base.prototype.toggle = function () {
        this.show = !this.show;
        if (this.show) {
            this.autoPosition();
        }
        console.log(this.show);
    };
    Base.prototype.bind = function (toggleDirective) {
        var _this = this;
        this.toggleDom = toggleDirective.dom;
        this.autoHandle = function () {
            if (!_this.ticking) {
                window.requestAnimationFrame(function () {
                    if (_this.show) {
                        _this.autoPosition();
                    }
                    _this.ticking = false;
                });
            }
            _this.ticking = true;
        };
        window.addEventListener('scroll', this.autoHandle, false);
        window.addEventListener('resize', this.autoHandle, false);
    };
    Base.prototype.autoPosition = function () {
        var _this = this;
        setTimeout(function () {
            var padPositon = _this.html.getPosition(_this.pad.nativeElement);
            var position = _this.html.getPosition(_this.toggleDom);
            var height = _this.html.getHeight(_this.toggleDom);
            _this.datepickerStyle.display = 'none';
            _this.datepickerStyle.left = position.x - padPositon.x + 'px';
            _this.datepickerStyle.top = height + position.y + 7.5 + 'px';
            var top = height + position.y + 7.5 + 300;
            if (window.innerHeight < top) {
                top = window.innerHeight - 300 - 7.5;
            }
            else {
                top = position.y + height + 7.5;
            }
            _this.datepickerStyle.top = top - padPositon.y + 'px';
            _this.datepickerStyle.display = '';
        });
    };
    Base.prototype.tryClose = function ($event) {
        if ($event.target === this.pad.nativeElement) {
            this.toggle();
        }
    };
    Base.propDecorators = {
        pad: [{ type: core_1.ViewChild, args: ['pad',] }]
    };
    return Base;
}(attr_class_1.DomAttr));
exports.Base = Base;
//# sourceMappingURL=base.class.js.map